GetField MACRO SrcDotField		; trashes and returns eax
LOCAL is, is2, src, field
  is INSTR <SrcDotField>, <.>
  if is
	is2 INSTR is+1, <SrcDotField>, <.>
	if is2 gt is
		is = is2
	endif
  else
	.err <## syntax: GetField(rec.field) ##>
  endif
  src SUBSTR <SrcDotField>, 1, is-1
  field SUBSTR <SrcDotField>, is+1
  ifdifi src, <eax>   
	mov eax, src
  endif
  and eax, mask field
  if field
	shr eax, field
  endif
  EXITM <eax>
ENDM

SetField MACRO SrcDotField, TheVal, forceAnd		; trashes and returns eax; checks immediate values for overflow
LOCAL is, is2, src, field, maxv, HasVal
  HasVal = 999					;; default: mov eax, TheVal
  is INSTR <SrcDotField>, <.>
  if is
	is2 INSTR is+1, <SrcDotField>, <.>
	if is2 gt is
		is = is2
	endif
  else
	.err <## syntax: SetField rec.field, 123 ##>
  endif
  src SUBSTR <SrcDotField>, 1, is-1
  field SUBSTR <SrcDotField>, is+1
  if ((opattr(TheVal)) AND 127) eq 36	; OPT_Errline 0
	HasVal = TheVal
	maxv = (2 SHL (WIDTH field - 1))-1		;; or gt with maxv = mask field SHR field
	if (TheVal gt maxv) or (TheVal lt -1)
		tmp$ CATSTR <## Line >, %@Line, <: overflow for SetField >, <SrcDotField>, <, >, <TheVal>, <, max=>, %maxv, < **>
		.err tmp$
	endif
  endif
  if HasVal
	ifdifi <TheVal>, <eax>
		if (HasVal ge -128) and (HasVal le 127)	;; 3 bytes
			if TheVal eq -1
				push maxv
			else
				push TheVal
			endif
			pop eax
		else
			mov eax, TheVal		;; 5 bytes
		endif
	endif
	if field
		shl eax, field
	endif
  else
	sub eax, eax
  endif
  ifnb <forceAnd>
	and src, not mask field
  endif
  or src, eax
ENDM
